From d88a2938e7e6a7299ca50e98dc04c7b3dd88fa8a Mon Sep 17 00:00:00 2001
From: Jacob Champion <jacob.champion@enterprisedb.com>
Date: Mon, 13 Jan 2025 12:31:59 -0800
Subject: [PATCH v48 7/8] XXX fix libcurl link error

The ftp/curl port appears to be missing a minimum version dependency on
libssh2, so the following starts showing up after upgrading to curl
8.11.1_1:

    libcurl.so.4: Undefined symbol "libssh2_session_callback_set2"

But 13.3 is EOL, so it's not clear if anyone would be interested in a
bug report, and a FreeBSD 14 Cirrus image is in progress. Hack past it
for now.
---
 .cirrus.tasks.yml | 1 +
 1 file changed, 1 insertion(+)

diff --git a/.cirrus.tasks.yml b/.cirrus.tasks.yml
index c192a077701..3afea832bc9 100644
--- a/.cirrus.tasks.yml
+++ b/.cirrus.tasks.yml
@@ -168,6 +168,7 @@ task:
     sysctl kern.corefile='/tmp/cores/%N.%P.core'
   setup_additional_packages_script: |
     pkg install -y curl
+    pkg upgrade -y libssh2 # XXX shouldn't be necessary. revisit w/ FreeBSD 14
 
   # NB: Intentionally build without -Dllvm. The freebsd image size is already
   # large enough to make VM startup slow, and even without llvm freebsd
-- 
2.34.1